# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.1
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""
The stfio module provides functions to read/write data from/to
common electrophysiology file formats
"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _stfio
else:
    import _stfio

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


class Recording(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _stfio.Recording_swiginit(self, _stfio.new_Recording(*args))
    __swig_destroy__ = _stfio.delete_Recording
    dt = property(_stfio.Recording_dt_get, _stfio.Recording_dt_set)
    file_description = property(_stfio.Recording_file_description_get, _stfio.Recording_file_description_set)
    time = property(_stfio.Recording_time_get, _stfio.Recording_time_set)
    date = property(_stfio.Recording_date_get, _stfio.Recording_date_set)
    comment = property(_stfio.Recording_comment_get, _stfio.Recording_comment_set)
    xunits = property(_stfio.Recording_xunits_get, _stfio.Recording_xunits_set)
    datetime = property(_stfio.Recording_datetime_get, _stfio.Recording_datetime_set)

    def __getitem__(self, at):
        return _stfio.Recording___getitem__(self, at)

    def __len__(self):
        return _stfio.Recording___len__(self)

    def write(self, *args):
        r"""
        Writes a Recording to a file.

            Arguments:
            fname  -- file name
        #ifndef TEST_MINIMAL
            ftype  -- file type (string). At present, only "hdf5" is supported.
        #else
            ftype  -- file type (string). At present, "hdf5", "gdf", "cfs" and "ibw" are supported.
        #endif // TEST_MINIMAL
            verbose-- Show info while writing

            Returns:
            True upon successful completion.Writes a Recording to a file.

            Arguments:
            fname  -- file name
        #ifndef TEST_MINIMAL
            ftype  -- file type (string). At present, only "hdf5" is supported.
        #else
            ftype  -- file type (string). At present, "hdf5", "gdf", "cfs" and "ibw" are supported.
        #endif // TEST_MINIMAL
            verbose-- Show info while writing

            Returns:
            True upon successful completion.Writes a Recording to a file.

            Arguments:
            fname  -- file name
        #ifndef TEST_MINIMAL
            ftype  -- file type (string). At present, only "hdf5" is supported.
        #else
            ftype  -- file type (string). At present, "hdf5", "gdf", "cfs" and "ibw" are supported.
        #endif // TEST_MINIMAL
            verbose-- Show info while writing

            Returns:
            True upon successful completion.
        """
        return _stfio.Recording_write(self, *args)

    def aspandas(self):
        import sys
        import numpy as np
        has_pandas = True
        try:
            import pandas as pd
        except ImportError:
            has_pandas = False
        if has_pandas:
            chnames = [ch.name for ch in self]
            channels = np.array([np.concatenate([sec for sec in ch]) for ch in self])
            date_range = pd.date_range(start=self.datetime, periods=channels.shape[1],
                                       freq='%dU' % np.round(self.dt*1e3))
            return pd.DataFrame(channels.transpose(), index=date_range, columns=chnames)
        else:
            sys.stderr.write("Pandas is not available on this system\n")
            return None


# Register Recording in _stfio:
_stfio.Recording_swigregister(Recording)

class Channel(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _stfio.Channel_swiginit(self, _stfio.new_Channel(*args))
    __swig_destroy__ = _stfio.delete_Channel
    name = property(_stfio.Channel_name_get, _stfio.Channel_name_set)
    yunits = property(_stfio.Channel_yunits_get, _stfio.Channel_yunits_set)

    def __getitem__(self, at):
        return _stfio.Channel___getitem__(self, at)

    def __len__(self):
        return _stfio.Channel___len__(self)

# Register Channel in _stfio:
_stfio.Channel_swigregister(Channel)

class Section(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, nparray):
        _stfio.Section_swiginit(self, _stfio.new_Section(nparray))
    __swig_destroy__ = _stfio.delete_Section

    def __getitem__(self, at):
        return _stfio.Section___getitem__(self, at)

    def __len__(self):
        return _stfio.Section___len__(self)

    def asarray(self):
        r"""Returns the section as a numpy array."""
        return _stfio.Section_asarray(self)

# Register Section in _stfio:
_stfio.Section_swigregister(Section)


def _read(filename, ftype, verbose, Data):
    r"""
    _read(filename, ftype, verbose, Data) -> bool
    Reads a file and returns a recording object.

    Arguments:
    filename -- file name
    #ifndef TEST_MINIMAL
    ftype    -- File type
    #else
    ftype    -- File type (obsolete)
    #endif // TEST_MINIMAL
    verbose  -- Show info while reading

    Returns:
    A recording object.
    """
    return _stfio._read(filename, ftype, verbose, Data)

def detect_events(*args, **kwargs):
    r"""
    detect_events(data, templ, dt, mode="criterion", norm=True, lowpass=0.5, highpass=0.0001) -> PyObject *


    Arguments:

    """
    return _stfio.detect_events(*args, **kwargs)

def peak_detection(invec, threshold, min_distance):
    r"""
    peak_detection(invec, threshold, min_distance) -> PyObject *


    Arguments:

    """
    return _stfio.peak_detection(invec, threshold, min_distance)

def risetime(invec, base, amp, frac=0.2):
    r"""
    risetime(invec, base, amp, frac=0.2) -> double


    Arguments:

    """
    return _stfio.risetime(invec, base, amp, frac)

import os

class StfIOException(Exception):
    """ raises Exceptions for the Stfio module """
    def __init__(self, error_msg):
        self.msg = error_msg 

    def __str__(self):
        return repr(self.msg)

filetype = {
    '.dat':'cfs',
    '.h5':'hdf5',
    '.abf':'abf',
    '.atf':'atf',
    '.axgd':'axg',
    '.axgx':'axg',
    '.clp':'intan'}

def read(fname, ftype=None, verbose=False):
    """Reads a file and returns a Recording object.

    Arguments:
    fname  -- file name
#ifndef TEST_MINIMAL
    ftype  -- file type (string); can be one of:
              "cfs"  - CED filing system
              "hdf5" - HDF5
              "abf"  - Axon binary file
              "atf"  - Axon text file
              "axg"  - Axograph X binary file
              "heka" - HEKA binary file
              "intan" - INTAN clamp binary file
              if ftype is None (default), it will be guessed from the
              extension.
#else
    ftype  -- file type (string) is obsolete.
              in the past it has been used to determine the file type.
              Now an automated file type identification is used, and this
              parameter become obsolete; eventually it will be removed.
#endif // TEST_MINIMAL
    verbose-- Show info while reading file

    Returns:
    A Recording object.
    """
    if not os.path.exists(fname):
        raise StfIOException('File %s does not exist' % fname)


    if ftype is None:
        ext = os.path.splitext(fname)[1]
        try:
            ftype = filetype[ext]
        except KeyError:
            raise StfIOException('Couldn\'t guess file type from extension (%s)' % ext)


    rec = Recording()
    if not _read(fname, ftype, verbose, rec):
        raise StfIOException('Error reading file')

    if verbose:
        print("")

    return rec


def read_tdms(fn):
    import numpy as np
    import sys
    try:
        from nptdms import TdmsFile
    except ImportError:
        sys.stderr.write("nptdms module unavailable")
        return None

    tdms_file = TdmsFile(fn)

    try:
        times = np.array(
            [[channel.data
              for channel in tdms_file.group_channels(group)
              if channel.data is not None]
             for group in tdms_file.groups()
             if group.lower() == "time"][0][0])
        dt = np.mean(np.diff(times))
    except IndexError:
        if not "Sampling Rate" in tdms_file.object().properties.keys():
            if not "Sampling Rate(AI)" in tdms_file.object().properties.keys():
                dt = 1.0
            else:
                sr = float(tdms_file.object().properties['Sampling Rate(AI)'])
                if sr > 0:
                    dt = 1e3/sr
                else:
                    dt = 1.0/25.0
        else:
            sr = float(tdms_file.object().properties['Sampling Rate'])
            if sr > 0:
                dt = 1e3/sr
            else:
                dt = 1.0/25.0

    return_dict = {
        "data": [
            [channel.data.astype(np.float64)
             for channel in tdms_file.group_channels(group)
             if channel.data is not None]
                 for group in tdms_file.groups()
            if group.lower()[:2] == "ai" or group.lower()[:2] == "ao"],
        "dt": dt,
    }
    return return_dict



